package nc.impl.xh.api;

import java.util.ArrayList;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.itf.ic.m45.self.IPurchaseInMaintain;
import nc.itf.ic.m46.IProductInMaitain;
import nc.itf.ic.m4a.IGeneralInMaintain;
import nc.itf.ic.m4c.self.ISaleOutMaintain;
import nc.itf.ic.m4d.IMaterialOutMaintain;
import nc.itf.ic.m4i.IGeneralOutMaintain;
import nc.itf.ic.m4k.IWhsTransMaintain;
import nc.itf.ic.m4n.ITransformMaitain;
import nc.itf.mmpac.pmo.pac0002.IPMOMaintainService;
import nc.itf.pu.m21.IOrderMaintain;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.ic.m45.entity.PurchaseInHeadVO;
import nc.vo.ic.m45.entity.PurchaseInVO;
import nc.vo.ic.m46.entity.FinProdInVO;
import nc.vo.ic.m47.entity.SubcontInHeadVO;
import nc.vo.ic.m47.entity.SubcontInVO;
import nc.vo.ic.m4a.entity.GeneralInVO;
import nc.vo.ic.m4c.entity.SaleOutHeadVO;
import nc.vo.ic.m4c.entity.SaleOutVO;
import nc.vo.ic.m4d.entity.MaterialOutHeadVO;
import nc.vo.ic.m4d.entity.MaterialOutVO;
import nc.vo.ic.m4i.entity.GeneralOutVO;
import nc.vo.ic.m4k.entity.WhsTransBillVO;
import nc.vo.ic.m4n.entity.TransformVO;
import nc.vo.mmpac.pmo.pac0002.entity.PMOAggVO;
import nc.vo.pu.m21.entity.OrderHeaderVO;
import nc.vo.pu.m21.entity.OrderVO;
import nc.vo.pu.m25.entity.InvoiceHeaderVO;
import nc.vo.pu.m25.entity.InvoiceVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.workflownote.WorkflownoteVO;
import nc.vo.sc.m61.entity.SCOrderHeaderVO;
import nc.vo.sc.m61.entity.SCOrderVO;
import nc.vo.so.m30.entity.SaleOrderHVO;
import nc.vo.so.m30.entity.SaleOrderVO;
import nc.vo.so.m32.entity.SaleInvoiceHVO;
import nc.vo.so.m32.entity.SaleInvoiceVO;
import nc.vo.arap.pay.PayBillVO;
import nc.vo.arap.gathering.AggGatheringBillVO;
import nc.vo.arap.pay.AggPayBillVO;
import nc.vo.arap.payable.PayableBillVO;
import nc.vo.arap.payable.AggPayableBillVO;
import net.sf.json.JSONObject;

/**
 *
 * ҵ񵥾ɾ
 * @author ZTH
 *
 */
public class DeltBusnesDcmentsImpl {
	private IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());	
	private IMDPersistenceQueryService service = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
	private WorkflownoteVO Workflownote = new WorkflownoteVO();
	private IPFBusiAction ipf = NCLocator.getInstance().lookup(IPFBusiAction.class);
	
   /**
    * 
    * 1.ɹɾ
    * 
    */
	public String DltPo_order(JSONObject json) throws BusinessException {
	   String vbillcode = json.getString("vbillcode");	//ɾĵݺ
	   //ݶŲѯVO
	   String sql="select * from po_order where vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";	
	   OrderHeaderVO orderheaderVO=(OrderHeaderVO)iuap.executeQuery(sql, new BeanProcessor(OrderHeaderVO.class));
	   if(orderheaderVO == null) {
			throw new BusinessException("ɹ:" + vbillcode + "ڣ");
	   }
	    //ѯAggVO
		//VOgatheringBillVO.getPk_gatherbill()
	    OrderVO orderVO=(OrderVO)service.queryBillOfNCObjectByPKWithDR(OrderHeaderVO.class,orderheaderVO.getPk_order(),true).getContainmentObject();
	    IOrderMaintain iodm=(IOrderMaintain)NCLocator.getInstance().lookup(IOrderMaintain.class);
	    OrderVO[] arr={orderVO};
	    iodm.delete(arr,null);
		return vbillcode;
	}
	
	/**
	 * 2.ɹⵥɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_purchasein(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("ɹⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<PurchaseInVO> purchaseInVO = (ArrayList<PurchaseInVO>) service.queryBillOfVOByCond(PurchaseInVO.class,sql,true,false);
		if(purchaseInVO.size()==0) {
			throw new BusinessException("ɹⵥݺ:" + vbillcode + "ڣ");
		}
		((IPurchaseInMaintain) NCLocator.getInstance().lookup(IPurchaseInMaintain.class)).delete(new PurchaseInVO[] {purchaseInVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 3.۳ⵥɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_saleout(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("۳ⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<SaleOutVO> saleOutVO = (ArrayList<SaleOutVO>) service.queryBillOfVOByCond(SaleOutVO.class,sql,true,false);
		if(saleOutVO.size()==0) {
			throw new BusinessException("۳ⵥݺ:" + vbillcode + "ڣ");
		}
		((ISaleOutMaintain)NCLocator.getInstance().lookup(ISaleOutMaintain.class)).delete(new SaleOutVO[] {saleOutVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 4.̬תɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_transform(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("̬תݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<TransformVO> transformVO = (ArrayList<TransformVO>) service.queryBillOfVOByCond(TransformVO.class,sql,true,false);
		if(transformVO.size()==0) {
			throw new BusinessException("̬תݺ:" + vbillcode + "ڣ");
		}
		((ITransformMaitain)NCLocator.getInstance().lookup(ITransformMaitain.class)).delete(new TransformVO[] {transformVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 5.תⵥɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_whstrans(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("תⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<WhsTransBillVO> whsTransBillVO = (ArrayList<WhsTransBillVO>) service.queryBillOfVOByCond(WhsTransBillVO.class,sql,true,false);
		if(whsTransBillVO.size()==0) {
			throw new BusinessException("תⵥݺ:" + vbillcode + "ڣ");
		}
		((IWhsTransMaintain)NCLocator.getInstance().lookup(IWhsTransMaintain.class)).delete(new WhsTransBillVO[] {whsTransBillVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 6.ɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_material(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("ϳⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<MaterialOutVO> materialOutVO = (ArrayList<MaterialOutVO>) service.queryBillOfVOByCond(MaterialOutVO.class,sql,true,false);
		if(materialOutVO.size()==0) {
			throw new BusinessException("ϳⵥݺ:" + vbillcode + "ڣ");
		}
		((IMaterialOutMaintain)NCLocator.getInstance().lookup(IMaterialOutMaintain.class)).delete(new MaterialOutVO[] {materialOutVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 7.ⵥɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_generalin(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("ⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<GeneralInVO> generalInVO = (ArrayList<GeneralInVO>) service.queryBillOfVOByCond(GeneralInVO.class,sql,true,false);
		if(generalInVO.size()==0) {
			throw new BusinessException("ⵥݺ:" + vbillcode + "ڣ");
		}
		((IGeneralInMaintain)NCLocator.getInstance().lookup(IGeneralInMaintain.class)).delete(new GeneralInVO[] {generalInVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 8.ⵥɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_generalout(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("ⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<GeneralOutVO> generalOutVO = (ArrayList<GeneralOutVO>) service.queryBillOfVOByCond(GeneralOutVO.class,sql,true,false);
		if(generalOutVO.size()==0) {
			throw new BusinessException("ⵥݺ:" + vbillcode + "ڣ");
		}
		((IGeneralOutMaintain)NCLocator.getInstance().lookup(IGeneralOutMaintain.class)).delete(new GeneralOutVO[] {generalOutVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 9.Ԥտ(ѹ۶)ɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltAr_gatheritemExpected(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("տݺǱ");
		}
		String sql="billno ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<AggGatheringBillVO> aggGatheringBillVO = (ArrayList<AggGatheringBillVO>) service.queryBillOfVOByCond(AggGatheringBillVO.class,sql,true,false);
		if(aggGatheringBillVO.size()==0) {
			throw new BusinessException("տݺ:" + vbillcode + "ڣ");
		}
		ipf.processAction("DELETE", "F2", Workflownote, aggGatheringBillVO.get(0), null, null);
		return vbillcode;
	}
	
	/**
	 * 10.տ(ѹ۶)ɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltAr_gatheritem(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("տݺǱ");
		}
		String sql="billno ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<AggGatheringBillVO> aggGatheringBillVO = (ArrayList<AggGatheringBillVO>) service.queryBillOfVOByCond(AggGatheringBillVO.class,sql,true,false);
		if(aggGatheringBillVO.size()==0) {
			throw new BusinessException("տݺ:" + vbillcode + "ڣ");
		}
		ipf.processAction("DELETE", "F2", Workflownote, aggGatheringBillVO.get(0), null, null);
		return vbillcode;
	}
	
	/**
	 * 11.ɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltMm_pmo(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("ݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<PMOAggVO> pmoAggVO = (ArrayList<PMOAggVO>) service.queryBillOfVOByCond(PMOAggVO.class,sql,true,false);
		if(pmoAggVO.size()==0) {
			throw new BusinessException("ݺ:" + vbillcode + "ڣ");
		}
		((IPMOMaintainService)NCLocator.getInstance().lookup(IPMOMaintainService.class)).delete(new PMOAggVO[] {pmoAggVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 12.ɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_materialget(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("ϳⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<MaterialOutVO> materialOutVO = (ArrayList<MaterialOutVO>) service.queryBillOfVOByCond(MaterialOutVO.class,sql,true,false);
		if(materialOutVO.size()==0) {
			throw new BusinessException("ϳⵥݺ:" + vbillcode + "ڣ");
		}
		((IMaterialOutMaintain)NCLocator.getInstance().lookup(IMaterialOutMaintain.class)).delete(new MaterialOutVO[] {materialOutVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 13.ɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_materialout(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("ϳⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<MaterialOutVO> materialOutVO = (ArrayList<MaterialOutVO>) service.queryBillOfVOByCond(MaterialOutVO.class,sql,true,false);
		if(materialOutVO.size()==0) {
			throw new BusinessException("ϳⵥݺ:" + vbillcode + "ڣ");
		}
		((IMaterialOutMaintain)NCLocator.getInstance().lookup(IMaterialOutMaintain.class)).delete(new MaterialOutVO[] {materialOutVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 14.ɾ
	 * @author LP
	 * @throws BusinessException 
	 */
	@SuppressWarnings("unchecked")
	public String DltIc_finprodin(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());
		String vbillcode = json.getString("vbillcode");
		if (vbillcode==null) {
			throw new BusinessException("ƷⵥݺǱ");
		}
		String sql="vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		ArrayList<FinProdInVO> finProdInVO = (ArrayList<FinProdInVO>) service.queryBillOfVOByCond(FinProdInVO.class,sql,true,false);
		if(finProdInVO.size()==0) {
			throw new BusinessException("Ʒⵥݺ:" + vbillcode + "ڣ");
		}
		((IProductInMaitain)NCLocator.getInstance().lookup(IProductInMaitain.class)).delete(new FinProdInVO[] {finProdInVO.get(0)});
		return vbillcode;
	}
	
	/**
	 * 15.ίⶩ
	 * @author Yaoy
	 * @param json
	 * @return
	 * @throws BusinessException
	 */
	public String DltSc_order(JSONObject json) throws BusinessException {
		String vbillcode = json.getString("vbillcode");	//ɾĵݺ
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		String sql = "select  pk_order from sc_order where  vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		SCOrderHeaderVO  sCOrderHeaderVO = (SCOrderHeaderVO) iuap.executeQuery(sql, new BeanProcessor(SCOrderHeaderVO.class));
		if(sCOrderHeaderVO == null) {
			throw new BusinessException("ίⶩ:" + vbillcode + "ڣ");
		}
		SCOrderVO  sCOrderVO = (SCOrderVO) service.queryBillOfNCObjectByPKWithDR(SCOrderVO.class,sCOrderHeaderVO.getPk_order(),true).getContainmentObject();
		ipf.processAction("DELETE", "61", Workflownote, sCOrderVO, null, null);
		return vbillcode;
	}
	
	/**
	 * 16.ϳ
	 * @author Yaoy
	 * @param json
	 * @return
	 * @throws BusinessException
	 */
	public String DltMaterial(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		String vbillcode = json.getString("vbillcode");	//ɾĵݺ
		String sql = "select cgeneralhid from ic_material_h  where vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		MaterialOutHeadVO materialOutHeadVO = (MaterialOutHeadVO) iuap.executeQuery(sql, new BeanProcessor(MaterialOutHeadVO.class));
		if(materialOutHeadVO == null) {
			throw new BusinessException("ϳ:" + vbillcode + "ڣ");
		}
		MaterialOutVO materialOutVO = (MaterialOutVO) service.queryBillOfNCObjectByPKWithDR(MaterialOutVO.class,materialOutHeadVO.getCgeneralhid(),true).getContainmentObject();
		ipf.processAction("DELETE", "4D", Workflownote, materialOutVO, null, null);
		return vbillcode;
	}
	
	/**
	 * 17.ίмӹ
	 * @author Yaoy
	 * @param json
	 * @throws BusinessException
	 */
	public String DltSubcontin(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		String vbillcode = json.getString("vbillcode");	//ɾĵݺ
		String sql = "select cgeneralhid  from ic_subcontin_h  where vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";
		SubcontInHeadVO subcontInHeadVO = (SubcontInHeadVO) iuap.executeQuery(sql, new BeanProcessor(SubcontInHeadVO.class));
		if(subcontInHeadVO == null) {
			throw new BusinessException("ίмӹ:" + vbillcode + "ڣ");
		}
		SubcontInVO subcontInVO = (SubcontInVO) service.queryBillOfNCObjectByPKWithDR(SubcontInVO.class,subcontInHeadVO.getCgeneralhid(),true).getContainmentObject();
		ipf.processAction("DELETE", "47", Workflownote, subcontInVO, null, null);
		return vbillcode;
	}
	
	/**
	 * 18
	 * @author pancy
	 * @param json
	 * @return
	 * @throws BusinessException
	 */
	public String DltAp_paybill(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		String vbillcode = json.getString("vbillcode");	//ɾĵݺ
		if (vbillcode.equals("")) {
			throw new BusinessException("дҪɾĵݺţ");
		}
		String sql = "select pk_paybill from ap_paybill where billno ='"+vbillcode+"' and nvl(dr,0)=0";
		PayBillVO paybillVO = (PayBillVO) iuap.executeQuery(sql, new BeanProcessor(PayBillVO.class));
		if(paybillVO == null) {
			throw new BusinessException(":" + vbillcode + "ڣ");
		}
		AggPayBillVO aggpaybillVO = (AggPayBillVO) service.queryBillOfNCObjectByPKWithDR(AggPayBillVO.class,paybillVO.getPk_paybill(),true).getContainmentObject();
		ipf.processAction("DELETE", "F3", Workflownote, aggpaybillVO, null, null);
		return vbillcode;
	}
	/**
	 * @author hej
	 * 19.ɹ˻
	 * 
	 * 
	**/
	public String Dltpurchasein_h(JSONObject json)throws BusinessException{
		String vbillcode = json.getString("vbillcode");	//ɾõݺ
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		   //ݶŲѯVO
		   String sql="select * from ic_purchasein_h where vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";	
		   PurchaseInHeadVO   pciVO=(PurchaseInHeadVO)iuap.executeQuery(sql, new BeanProcessor(PurchaseInHeadVO.class));
		  if(pciVO == null) {
				throw new BusinessException("ݺ:" + vbillcode + "ڣ");
		   }
		//ѯAggVO
			//VOgatheringBillVO.getPk_gatherbill()
		  PurchaseInVO  AggpciVO=(PurchaseInVO)service.queryBillOfNCObjectByPKWithDR(PurchaseInHeadVO.class,pciVO.getCgeneralhid(),true).getContainmentObject();		  
		  IPurchaseInMaintain ipmt=(IPurchaseInMaintain)NCLocator.getInstance().lookup(IPurchaseInMaintain.class);
		  PurchaseInVO[] brr={AggpciVO};
		  ipmt.delete(brr);		  
		  return vbillcode+"ɾɹ";
	}
		 
	/**
	 * @author hej
	 * 20.۶
	 * 
	 * 
	 * **/	  
	public String Dltso_saleorder(JSONObject json)throws BusinessException{
		String vbillcode = json.getString("vbillcode");	//ɾõݺ
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		   //ݶŲѯVO
		   String sql="select * from so_saleorder where vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";	
		   SaleOrderHVO soVO=(SaleOrderHVO)iuap.executeQuery(sql, new BeanProcessor(SaleOrderHVO.class));
		  if(soVO == null) {
				throw new BusinessException("ݺ:" + vbillcode + "ڣ");
		   }
		//ѯAggVO
			//VOgatheringBillVO.getPk_gatherbill()
		  SaleOrderVO salVO=(SaleOrderVO )service.queryBillOfNCObjectByPKWithDR(SaleOrderHVO.class,soVO.getCsaleorderid(),true).getContainmentObject();		  
		 ipf.processAction("DELETE", "m30", Workflownote, salVO, null, null);	  
		  return vbillcode+"ɾɹ";
	
	}	
	/**
	 * @author hej
	 * 21.۳/˻
	 * 
	 * 
	 * **/	  
	public String Dltsaleout_h(JSONObject json)throws BusinessException{
		String vbillcode = json.getString("vbillcode");	//ɾõݺ
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		   //ݶŲѯVO
		   String sql="select * from ic_saleout_h where vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";	
		   SaleOutHeadVO  sohVO=(SaleOutHeadVO )iuap.executeQuery(sql, new BeanProcessor(SaleOutHeadVO .class));
		  if(sohVO == null) {
				throw new BusinessException("ݺ:" + vbillcode + "ڣ");
		   }
		//ѯAggVO
			//VOgatheringBillVO.getPk_gatherbill()
		  SaleOutVO  saloVO=(SaleOutVO )service.queryBillOfNCObjectByPKWithDR(SaleOutHeadVO.class,sohVO.getCgeneralhid(),true).getContainmentObject();		  
		 ipf.processAction("DELETE", "m4c", Workflownote, saloVO, null, null);	  
		  return vbillcode+"ɾɹ";
	
	}	
	/**
	 * @author hej
	 * 22.۷Ʊ
	 * 
	 * 
	 * **/	  
	public String Dltso_saleinvoice(JSONObject json)throws BusinessException{
		String vbillcode = json.getString("vbillcode");	//ɾõݺ
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		   //ݶŲѯVO
		   String sql="select * from so_saleinvoice where vbillcode ='"+vbillcode+"' and nvl(dr,0)=0";	
		   SaleInvoiceHVO  sicVO=(SaleInvoiceHVO)iuap.executeQuery(sql, new BeanProcessor(SaleInvoiceHVO.class));
		  if(sicVO == null) {
				throw new BusinessException("ݺ:" + vbillcode + "ڣ");
		   }
		//ѯAggVO
			//VOgatheringBillVO.getPk_gatherbill()
		  SaleInvoiceVO salVO=(SaleInvoiceVO )service.queryBillOfNCObjectByPKWithDR(SaleInvoiceHVO.class,sicVO.getCsaleinvoiceid(),true).getContainmentObject();		  
		 ipf.processAction("DELETE", "m32", Workflownote, salVO, null, null);	  
		  return vbillcode+"ɾɹ";
	
	}	
	
	
	/**
	 * 23Ӧ
	 * @author pancy
	 * @param json
	 * @return
	 * @throws BusinessException
	 */
	public String DltAp_payablebill(JSONObject json) throws BusinessException {
		InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָpk
		String vbillcode = json.getString("vbillcode");	//ɾĵݺ
		if (vbillcode.equals("")) {
			throw new BusinessException("дҪɾĵݺţ");
		}
		String sql = "select pk_payablebill  from ap_payablebill where billno ='"+vbillcode+"' and nvl(dr,0)=0";
		PayableBillVO payablebillVO = (PayableBillVO) iuap.executeQuery(sql, new BeanProcessor(PayableBillVO.class));
		if(payablebillVO == null) {
			throw new BusinessException(":" + vbillcode + "ڣ");
		}
		AggPayableBillVO aggpayablebillVO = (AggPayableBillVO) service.queryBillOfNCObjectByPKWithDR(AggPayableBillVO.class,payablebillVO.getPk_payablebill(),true).getContainmentObject();
		ipf.processAction("DELETE", "F1", Workflownote, aggpayablebillVO, null, null);
		return vbillcode;
	}
	
	/**
	 * 24ɹƱɾ
	 * @author lyr
	 * @param json
	 * @return
	 * @throws BusinessException
	 */
	public String DltPo_invoice(JSONObject json) throws BusinessException {
	   InvocationInfoProxy.getInstance().setGroupId(QueryGroup());//ָ
	   String vbillcode = json.getString("vbillcode"); //ɾõݺ
	   String sql="select * from po_invoice where vbillcode ='"+vbillcode+"' and nvl(dr,0)=0"; 
	   InvoiceHeaderVO invoiceHeaderVO = (InvoiceHeaderVO)iuap.executeQuery(sql, new BeanProcessor(InvoiceHeaderVO.class));
	   if(invoiceHeaderVO == null) {
	    throw new BusinessException("ɹƱ:" + vbillcode + "ڣ");
	   }
	   InvoiceVO invoiceVO=(InvoiceVO)service.queryBillOfNCObjectByPKWithDR(InvoiceHeaderVO.class,invoiceHeaderVO.getPk_invoice(),true).getContainmentObject();
	   ipf.processAction("DELETE", "25", Workflownote, invoiceVO, null, null);
	   return vbillcode;
	  }
	
	public String QueryGroup() throws BusinessException {
		String sql = "select pk_group from org_group where code='ZJC' and nvl(dr,0)=0";
		String pk_group = (String) iuap.executeQuery(sql, new ColumnProcessor());
		return pk_group;
	}
	
	
}

